Attribute VB_Name = "GameModule"
Option Explicit

Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Declare Function GetKeyState Lib "user32" (ByVal KeyCode As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Sub ReleaseCapture Lib "user32" ()
Declare Sub Sleep Lib "kernel32" (ByVal Interval As Long)

Type Slange
x As Integer
y As Integer
Retning As Double
End Type

Type GameBoks
Vei As Integer
Snu As Boolean
Boks As Integer
End Type

Global MCaption As String
Global Vei As Integer
Global Boks() As GameBoks
Global E(1) As Integer
Global Game As Boolean
Global Max As Integer
Global Level As Integer
Global Poeng As Long
Global Replay As String
Global Tell As Integer

Global MX%, MY%
Global CX%, CY%, Created As Boolean
Global lText As Boolean
Global MText As String

Global PreCalc() As Integer

Public Sub MainLoop()

Dim Snu As Boolean

lText = False

With Form1
Do Until Game = False

Snu = False

If Not Tell >= 8999 Then Tell = Tell + 1

If GetKeyState(vbKeyLeft) < 0 And Not Vei = 0 Then Snu = True: Vei = 1: Replay = Replay & Tell & 1: Tell = 1000
If GetKeyState(vbKeyRight) < 0 And Not Vei = 1 Then: Snu = True: Vei = 0: Replay = Replay & Tell & 0: Tell = 1000
If Vei = 0 Then MX = MX + 1
If Vei = 1 Then MX = MX - 1
If MX < 0 Then MX = E(0)
If MX > E(0) Then MX = 0

If GetKeyState(vbKeyUp) < 0 And Not Vei = 3 Then: Snu = True: Vei = 2: Replay = Replay & Tell & 2: Tell = 1000
If GetKeyState(vbKeyDown) < 0 And Not Vei = 2 Then: Snu = True: Vei = 3: Replay = Replay & Tell & 3: Tell = 1000
If Vei = 2 Then MY = MY - 1
If Vei = 3 Then MY = MY + 1
If MY < 0 Then MY = E(1)
If MY > E(1) Then MY = 0

If Not Boks(MX, MY).Boks = 0 Then
Draw
lText = True
MText = "You lose! Press here to restart" & Chr(13) & "You can also press right" & Chr(13) & "mousebutton to se the replay"
.Picture1.Line (MX * 8, MY * 8)-((MX * 8) + 8, (MY * 8) + 8), RGB(255, 255, 255), BF
.Picture1_Paint
Exit Sub
End If

If MX = CX And MY = CY Then
Ny:
CX = Rnd * E(0)
CY = Rnd * E(1)
If Not Boks(CX, CY).Boks = 0 Then GoTo Ny
BitBlt Form1.Picture1.hDC, CX * 8, CY * 8, Form1.Picture4.ScaleWidth, Form1.Picture4.ScaleHeight, Form1.Picture4.hDC, 0, 0, vbSrcCopy
Replay = Replay & "0" & Mer(CX) & Mer(CY)
Level = Level + 1
Max = Max + 1
Poeng = Poeng + Max
.Label1.Caption = "Points: " & Poeng & " - " & "Level: " & Level
End If

Boks(MX, MY).Boks = Max
Boks(MX, MY).Vei = Vei
Boks(MX, MY).Snu = Snu
DrawSnakeBody MX, MY
Form1.Picture1.Line (MX * 8, MY * 8)-((MX * 8) + 7, (MY * 8) + 7), RGB(150, 150, 150), BF

Draw

If Level = 50 Then
Game = False
Vinn
End If

Sleep (100 - (Level * 2))
DoEvents
Loop
End With

End Sub

Public Sub DrawSnakeBody(ByVal MX As Integer, ByVal MY As Integer)

Form1.Picture1.Line (MX * 8, MY * 8)-((MX * 8) + 7, (MY * 8) + 7), RGB(150, 150, 150), BF

End Sub

Public Sub GameReplay()

Dim Number, C
Dim Tell2 As Integer
Dim Text As Boolean
Dim Snu As Boolean

Number = 1
Level = 0
lText = False

ReDim Boks(E(0), E(1))

Boks(0, 0).Boks = 5

Poeng = 0
MX = 0
MY = 0
Vei = 0
CX = E(0) / 2
CY = E(1) / 2
Max = 5
Tell = 1000
Form1.Label1.Caption = "Points: " & Poeng & " - " & "Level: " & Level
Form1.Picture1_Paint

Do Until Number >= Len(Replay)

Snu = False

Tell = Tell + 1
Tell2 = Tell2 + 1

If Tell2 > 3 Then
Tell2 = 0
Text = Not Text
If Text = False Then Form1.Picture1_Paint
End If

If Text = True Then
Form1.Picture1.FontSize = 12
Form1.Picture1.CurrentX = Form1.Picture1.Width - Form1.Picture1.TextWidth("Replay") - 120
Form1.Picture1.CurrentY = 0
Form1.Picture1.Print "Replay"
Form1.Picture1.FontSize = 8
End If

A:
If Tell = Mid(Replay, Number, 4) Then
Tell = 1000
Number = Number + 4
Vei = Mid(Replay, Number, 1)
Snu = True
Number = Number + 1
If Number > Len(Replay) Then Exit Sub
If Tell = Mid(Replay, Number, 4) Then GoTo A
End If

If Vei = 0 Then MX = MX + 1
If Vei = 1 Then MX = MX - 1
If Vei = 2 Then MY = MY - 1
If Vei = 3 Then MY = MY + 1

If MX < 0 Then MX = E(0)
If MX > E(0) Then MX = 0
If MY < 0 Then MY = E(1)
If MY > E(1) Then MY = 0

If MX = CX And MY = CY Then
Number = Number + 1
CX = Mid(Replay, Number, 2)
Number = Number + 2
CY = Mid(Replay, Number, 2)
Number = Number + 2
Level = Level + 1
Max = Max + 1
Poeng = Poeng + Max
Form1.Label1.Caption = "Points: " & Poeng & " - " & "Level: " & Level
Game = False
End If

Boks(MX, MY).Boks = Max
Boks(MX, MY).Vei = Vei
Boks(MX, MY).Snu = Snu
DrawSnakeBody MX, MY

Draw

Sleep (100 - (Level * 2))
DoEvents
Loop

lText = True
MText = "Press here to restart" & Chr(13) & "Press right mousebutton to se the replay agian"
Form1.Picture1.FontSize = 12
Form1.Picture1_Paint
Form1.Label1.Caption = "Points: 0 - Level: 0"
Form1.Picture1.FontSize = 8

End Sub

Public Function Mer(Tall As Integer) As String

Dim Buffer

Buffer = Tall

If Len(Buffer) < 2 Then
Mer = "0" & Buffer
Else
    Mer = Buffer
    End If

End Function

Public Sub Draw()

Dim A%, B%

For A = 0 To E(0)
For B = 0 To E(1)

If Not Boks(A, B).Boks = 0 Then
Boks(A, B).Boks = Boks(A, B).Boks - 1
If Boks(A, B).Boks = 0 Then BitBlt Form1.Picture1.hDC, A * 8, B * 8, 8, 8, Form1.Picture2.hDC, PreCalc(A), PreCalc(B), vbSrcCopy: GoTo A
End If

A:
Next
Next

End Sub

Sub Vinn()

lText = True
MText = "DU HAR VUNNET!"
Form1.Picture1_Paint

End Sub

Public Sub Ny()

E(0) = (Form1.Picture1.Width / 8) - 1
E(1) = (Form1.Picture1.Height / 8) - 1

Replay = ""
Poeng = 0
Level = 0
MX = 0
MY = 0
CX = E(0) / 2
CY = E(1) / 2
Vei = 0
Max = 5
Tell = 1000
Form1.Label1.Caption = "Points: " & Poeng & " - " & "Level: " & Level

ReDim Boks(E(0), E(1))

Boks(0, 0).Boks = Max
Created = True
Form1.Picture1_Paint

End Sub

